source stooop.tcl
namespace import stooop::*

### check user defined cloning operation error checking

# expected output:
## class ::a constructor first argument must be this
## class ::A constructor first argument must be this
## class ::b::c constructor first argument must be this
## class ::B::C constructor first argument must be this

catch {
    class a {}
    proc a::a {this} {
        set ($this,x) 0
    }
    proc a::a {destination source} {}
    new [new a]
} message
puts $message

catch {
    class A {
        proc A {this} {
            set ($this,x) 0
        }
        proc A {destination source} {}
    }
    new [new A]
} message
puts $message

catch {
    class b {}
    class b::c {}
    proc b::c::c {this} {
        set ($this,x) 0
    }
    proc b::c::c {destination source} {}
    new [new b::c]
} message
puts $message

catch {
    class B {
        class C {
            proc C {this} {
                set ($this,x) 0
            }
            proc C {destination source} {}
        }
        new [new C]
    }
} message
puts $message
