source stooop.tcl
namespace import stooop::*

### check that multiple declarations that can occur when a class declaration file is sourced multiple times have no adverse effects

# expected output:

class a {}
proc a::a {this} {}
class b {}
proc b::b {this} a {} {}
proc b::b {this} a {} {}

class A {
    proc A {this} {}
}
class B {
    proc B {this} A {} {}
}
class B {
    proc B {this} A {} {}
}

class c {}
class c::d {}
proc c::d::d {this} {}
class c::e {}
proc c::e::e {this} c::d {} {}
proc c::e::e {this} c::d {} {}

class C {
    class D {
        proc D {this} {}
    }
    class E {
        proc E {this} C::D {} {}
    }
    class E {
        proc E {this} C::D {} {}
    }
}
